/**
 * salte-filter JavaScript Library v2.0.0
 *
 * @license MIT (https://github.com/salte-io/salte-auth/blob/master/LICENSE)
 *
 * Made with ♥ by Nick Woodward <nick@salte.io>
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("angular"));
	else if(typeof define === 'function' && define.amd)
		define("salte-filter", ["angular"], factory);
	else if(typeof exports === 'object')
		exports["salte-filter"] = factory(require("angular"));
	else
		root["salte-filter"] = factory(root["angular"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE_angular__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ({

/***/ "./salte-filter.component.js":
/*!***********************************!*\
  !*** ./salte-filter.component.js ***!
  \***********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _salteFilter = __webpack_require__(/*! ./salte-filter.html */ "./salte-filter.html");

var _salteFilter2 = _interopRequireDefault(_salteFilter);

var _salteFilterController = __webpack_require__(/*! ./salte-filter.controller.js */ "./salte-filter.controller.js");

var _salteFilterController2 = _interopRequireDefault(_salteFilterController);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  transclude: true,
  template: _salteFilter2.default,
  controller: _salteFilterController2.default,
  bindings: {
    data: '<',
    filteredData: '=',
    onFilter: '&'
  }
};

/***/ }),

/***/ "./salte-filter.controller.js":
/*!************************************!*\
  !*** ./salte-filter.controller.js ***!
  \************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SalteFilter = function () {
  function SalteFilter() {
    _classCallCheck(this, SalteFilter);

    this.filters = [];
    this.listeners = [];
  }

  _createClass(SalteFilter, [{
    key: "$onChanges",
    value: function $onChanges(changes) {
      if (changes.data) {
        this.filter();
      }
    }
  }, {
    key: "filter",
    value: function filter() {
      var _this = this;

      this.filteredData = [];
      if (this.data) {
        this.data.forEach(function (data) {
          var valid = true;
          _this.filters.forEach(function (filter) {
            if (!filter(data)) {
              valid = false;
            }
          });
          if (valid) {
            _this.filteredData.push(data);
          }
        });
      }
      this.listeners.forEach(function (listener) {
        return listener(_this.filteredData);
      });
      this.onFilter({
        filteredData: this.filteredData
      });
    }
  }, {
    key: "addFilter",
    value: function addFilter(filter) {
      if (this.filters.indexOf(filter) === -1) {
        this.filters.push(filter);
        this.filter();
      }
    }
  }, {
    key: "addFilterListener",
    value: function addFilterListener(listener) {
      if (!listener) return;
      this.listeners.push(listener);
    }
  }, {
    key: "removeFilterListener",
    value: function removeFilterListener(listener) {
      var index = this.listeners.indexOf(listener);
      if (index !== -1) {
        this.listeners.splice(index, 1);
      }
    }
  }, {
    key: "removeFilter",
    value: function removeFilter(filter) {
      var index = this.filters.indexOf(filter);
      if (index !== -1) {
        this.filters.splice(index, 1);
        this.filter();
      }
    }
  }]);

  return SalteFilter;
}();

exports.default = SalteFilter;

/***/ }),

/***/ "./salte-filter.html":
/*!***************************!*\
  !*** ./salte-filter.html ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<ng-transclude></ng-transclude>\n";

/***/ }),

/***/ "./salte-filter.module.js":
/*!********************************!*\
  !*** ./salte-filter.module.js ***!
  \********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _angular = __webpack_require__(/*! angular */ "angular");

var _angular2 = _interopRequireDefault(_angular);

var _salteFilterComponent = __webpack_require__(/*! ./salte-filter.component.js */ "./salte-filter.component.js");

var _salteFilterComponent2 = _interopRequireDefault(_salteFilterComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _module = _angular2.default.module('salte.filter', []);

_module.component('salteFilter', _salteFilterComponent2.default);

exports.default = _module.name;

/***/ }),

/***/ 0:
/*!**************************************!*\
  !*** multi ./salte-filter.module.js ***!
  \**************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(/*! ./salte-filter.module.js */"./salte-filter.module.js");


/***/ }),

/***/ "angular":
/*!**************************!*\
  !*** external "angular" ***!
  \**************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_angular__;

/***/ })

/******/ });
});
//# sourceMappingURL=salte-filter.js.map